<%@page contentType="text/html"%>

<html>
<head><title>KEGVis</title></head>
<body>
<%
    //    KVWSession kvsession = new KVWSession("play/gxl/coffee1.xml");
    //    kvsession.setCtlString("EX((power = DN) /\\ (cup = DC))");
    KVWSession kvsession = (KVWSession) request.getAttribute("kvwsession");
    if (kvsession == null) {
        out.println("problem: missing counter-example");
        return;
    }
    String filename = (String) request.getAttribute("filename");
    String ctlString = (String) request.getAttribute("ctlString");
%>
<a href="/kegvis/KVWServlet?command=step1">Add 1 Step</a><br>
<a href="/kegvis/KVWServlet?command=reset">Reset trace</a><br>
<form action="/kegvis/KVWServlet"><input type="hidden" name="command" value="newctl"><input type="text" name="ctl" value="<%=ctlString%>" size="80"><input type="submit" name="submit" value="Run CTL"></form>
<hr>
    Using [<%=ctlString%>] on <%=filename%><br>
    <table border="1">
<%    for (java.util.ListIterator sit = kvsession.getStateIterator(); sit.hasNext();) {
      KVWState state = (KVWState) sit.next();
      
      // just transitioned?
      if (sit.previousIndex() > 0) {
%>
        <tr><td><!-- (begin transition) -->
            <%=state.getTransValue()%>
        </td><td>
<%        if (state.getNeighbours().size() > 0) {
%>
          Other states needed:
<%          for (java.util.Iterator asit = state.getNeighbours().iterator(); asit.hasNext();) {
%>
            <a target="_blank" href="#"><%=asit.next().toString()%></a>
<%          }
        }
%>
        </td></tr><!-- (end transition) -->
<%      }
      
      if (kvsession.getStatefilter().isDisplayable(state)) {
%>      
        <tr><!-- (begin staterow) -->
        <td><!-- (begin display state) -->
        <table>
<%
        if (state.isLabelized()) {
%>
          <tr><td><!-- (begin label) -->
            <%=state.getLabel()%>
          </td></tr><!-- (end label) -->
<%        }
        for (java.util.Iterator pit = state.getPropIterator(); pit.hasNext();) {
          KVWStateProperty prop = (KVWStateProperty) pit.next();
          if (kvsession.getPropfilter().isDisplayable(prop)) {
%>
            <tr><td><!-- (begin prop) -->
                <%=prop.getName()%>
            </td><td>
                <%=prop.getValue()%>
            </td></tr><!-- (end prop) -->
<%          } else {
%>
            <!-- skip prop -->
<%
          }
        }
%>
        </table></td><!-- (end display state) -->
        
<%        // now the CTL side %>
        <td valign="top"><table><!-- (begin display CTL) -->
<%        // maybe show a header row here
        for (java.util.Iterator cit = state.getCtl().iterator(); cit.hasNext();) {
          KVWCtlExpression ctlex = (KVWCtlExpression) cit.next();
          if (kvsession.getCtlfilter().isDisplayable(ctlex)) {
%>
            <tr><td><!-- (begin ctl) -->
                <%=ctlex.toHtml()%>
            </td><td>
                <%=ctlex.nextOp()%>
            </td></tr><!-- (end ctl) -->
<%          } else {
%>
            <!-- skip ctlex -->
<%          }
        }
%>
        </table></td><!-- (end display CTL) -->
        </tr><!-- (end staterow) -->
<%      } else {
%>
        <!-- skip state -->
<%      }
    }
%>
    </table><!-- (all done) -->

</body>
</html>
